program Ti2Hex;
{$APPTYPE CONSOLE}
uses
  windows, sysutils;

var f,g:textfile;
    s,s2,adresse:string;
    i,adr,adrcnt,bcnt,ll:integer;
    hexeof:boolean;

function hex2int(zahl:string):longint;
var i,c: integer;
    erg,f: longint;

 function getzahl(z:char):longint;
 var s: string;
 begin
  case z of
  'A': getzahl:=10;
  'B': getzahl:=11;
  'C': getzahl:=12;
  'D': getzahl:=13;
  'E': getzahl:=14;
  'F': getzahl:=15;
  else begin s:=z; getzahl:=strtoint(s); end;
  end;
 end;

begin
  erg:=0;
  zahl:=trim(zahl);
  if length(zahl)=0 then begin result:=-1; exit; end;
  for i:=length(zahl) downto 1 do
  begin
   f:=1;
   if i<length(zahl) then for c:=1 to length(zahl)-i do f:=f*16;
   erg:=erg+getzahl(zahl[i])*f;
  end;
  result:=erg;
end;

function removespaces(txt:string):string;
var c:integer;
begin
  result:=txt;
  if length(txt)=0 then exit;
  c:=1;
  while c<=length(txt) do if txt[c]=' ' then delete(txt,c,1) else inc(c);
  result:=txt;
end;

function gencsum(txt:string):string;
var c,sum:integer;
begin
  result:='00';
  if length(txt)=0 then exit;
  delete(txt,1,1);
  sum:=0;
  for c:=1 to length(txt)div 2 do
  begin
    sum:=(sum+hex2int(copy(txt,c*2-1,2))) and 255;
  end;
  result:=inttohex(256-sum,2);
end;

begin
  writeln('TI-TXT zu Intel HEX Format Konverter  (Version 1.0)                            ');
  writeln('(C) 2003 SimSoft Inc.');
  writeln('');
  if FindCmdLineSwitch('h', ['/','-'], true) or (paramcount<2) then
  begin
  //  #132      #148      #129      #142      #153      #154
    writeln('TI2HEX <Quelldatei> <Ausgabedatei> [-h]');
    writeln('<Quelldatei> und <Ausgabedatei> m'#129'ssen immer angegeben werden!');
    writeln('');
    writeln('Parameter:');
    writeln('  -h        Zeigt diesen Hilfebildschirm');
    exit;
  end;

  try
    assignfile(f,paramstr(1));
    reset(f);
    writeln('Quelldatei <'+paramstr(1)+'>');
  except
    writeln('Fehler beim Laden der angegebenen Datei "'+paramstr(1)+'"');
    exit;
  end;

  try
    assignfile(g,paramstr(2));
    rewrite(g);
    writeln('Ausgabedatei <'+paramstr(2)+'>');
  except
    writeln('Fehler beim Anlegen der Ausgabedatei "'+paramstr(2)+'"');
    exit;
  end;

  hexeof:=false;
  adr:=0;
  s2:='';
  bcnt:=0;
  adrcnt:=0;

  while (not eof(f)) and (not hexeof) do
  begin
    readln(f,s);

    if length(s)>0 then
    begin

      if s[1]='q' then
      begin
        hexeof:=true;
        writeln(g,':00000001FF');
      end else
      begin
        if s[1]='@' then
        begin
          adresse:=copy(s,2,4);
          adr:=hex2int(adresse);
          inc(adrcnt);
        end else
        begin
          ll:=(length(s)+1)div 3;
          s2:=':'+inttohex(ll,2)+inttohex(adr,4)+'00'+removespaces(s);
          s2:=s2+gencsum(s2);
          adr:=adr+ll;
          bcnt:=bcnt+ll;
          writeln(g,s2);
        end;
      end;

    end;
  end;
  if not hexeof then writeln(g,':00000001FF');

  writeln('');
  writeln('Statistik:');
  writeln('  '+inttostr(bcnt)+' Bytes konvertiert');
  writeln('  '+inttostr(adrcnt)+' Adressbereiche gefunden');
  writeln('');
  closefile(f);
  closefile(g);
//  writeln(paramstr(paramcount));
  if FindCmdLineSwitch('p', ['/','-'], true) then
  begin
    writeln('MSP430 BSL Programmer starten...');
    s:=paramstr(paramcount)+' '+paramstr(2);
    writeln('BSLDEMO '+s);
    writeln('');
    i:=winexec(pchar('bsldemo '+s),SW_SHOWNORMAL);
    if i=ERROR_BAD_FORMAT then writeln('Nichtausfuehrbare Datei!');
    if i=ERROR_FILE_NOT_FOUND then writeln('BSLDEMO.EXE nicht gefunden!');
    if i=ERROR_PATH_NOT_FOUND then writeln('Verzeichnis nicht gefunden!');
    writeln('');
    writeln('>> Nach Ende des Programmierens Enter dr'#129'cken! <<');
    writeln('');
  end;
end.
